<?
/************************************************************************************************
TiddlyWiki 1.0 copyright by Jeremy Ruston, 20 September 2004
jeremy@osmosoft.com
PhpTiddlyWiki is an extension by Patrick Curry, 2004-2007
wiki(at)patrickcurry(dot)com

This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike License.
To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/2.0/ or send
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
************************************************************************************************/

// this file actually creates the database and tables needed to use PhpTiddlyWiki.  Be sure to setup the values in tiddly_conf.php FIRST!!!
// also, I recommend you delete this file after you run it...

include("tiddly_conf.php");

?>
<html>
<head>
<title>PhpTiddlyWiki Install</title>
</head>
<body>
<h1>PhpTiddlyWiki Install</h1>
<p>Beginning database install now...</p>
<?

print("<p>Attempting to connect to database server... ");

$link = mysql_connect($tiddly_db_host, $tiddly_db_login, $tiddly_db_pass)
  or die(mysql_error());
  
print("Connected to database server!</p>");

/* NOTE: You may want to use PhpTiddlyWiki in an existing database.  If so, comment out this block of code: */

print("<p>Attempting to create Tiddly database... ");

 if (mysql_create_db($tiddly_db_name)) {
        print ("Tiddly database created successfully!</p>");
    } else {
        printf ("Error creating database: %s\n", mysql_error());
    }

print("Database created!</p>");

/* End comment block here! */

print("<p>Attempting to use Tiddly database... ");

mysql_select_db($tiddly_db_name) or die(mysql_error());

print("Database being used!</p>");

print("<p>Attempting to create entry table... ");

$query = "CREATE TABLE " . $tiddly_db_table_name . " (  id int(11) NOT NULL auto_increment,  title varchar(255) NOT NULL default '',  body text NOT NULL,  modified varchar(128) NOT NULL default '',  modifier varchar(255) NOT NULL default '',  created varchar(128) NOT NULL default '',  creator varchar(128) NOT NULL default '',  version int(11) NOT NULL default '0',  tags varchar(128) NOT NULL default '', PRIMARY KEY  (id),  UNIQUE KEY title_2 (title),  KEY title (title)) TYPE=MyISAM;";
$result = mysql_query($query) or die(mysql_error());

print("Table created!</p>");

print("<p>Attempting to create backup entry table... ");

$query = "CREATE TABLE " . $tiddly_db_backup_table_name . " (  id int(11) NOT NULL auto_increment,  title varchar(255) NOT NULL default '',  body text NOT NULL,  modified varchar(128) NOT NULL default '',  modifier varchar(255) NOT NULL default '',  version int(11) NOT NULL default '0',  tags varchar(128) NOT NULL default '', PRIMARY KEY  (id)) TYPE=MyISAM;";
$result = mysql_query($query) or die(mysql_error());

print("Table created!</p>");

print("<p>Attempting to insert starter tiddlers (entries)...");

$query = "INSERT INTO " . $tiddly_db_table_name . " VALUES (1, 'SiteTitle', 'Another PhpTiddlyWiki', '200410180100', '(unknown)', '200410180100', '(unknown)', 0, 'UI')";
$result = mysql_query($query) or die(mysql_error());
$query = "INSERT INTO " . $tiddly_db_table_name . " VALUES (2, 'SiteSubtitle', 'Your site is up and running!', '200410180100', '(unknown)', '200410180100', '(unknown)', 0, 'UI')";
$result = mysql_query($query) or die(mysql_error());
$query = "INSERT INTO " . $tiddly_db_table_name . " VALUES (3, 'MainMenu', 'StartHere\r\n', '200410180100', '(unknown)', '200410180100', '(unknown)', 0, 'UI')";
$result = mysql_query($query) or die(mysql_error());
$query = "INSERT INTO " . $tiddly_db_table_name . " VALUES (4, 'StartHere', 'You\'ve just installed PhpTiddlyWiki!  Good show!  Now start making NewTiddlers!', '200410180101', '(unknown)', '200410180101', '(unknown)', 0, 'UI')";
$result = mysql_query($query) or die(mysql_error());
$query = "INSERT INTO " . $tiddly_db_table_name . " VALUES (5, 'DefaultTiddlers', 'StartHere', '200410180101', '(unknown)', '200410180101', '(unknown)', 0, 'UI')";
$result = mysql_query($query) or die(mysql_error());

print("Entries inserted!</p>");

mysql_close($link);

print("<p>PhpTiddlyWiki Setup Complete!!!  <a href=\"index.php\" target=\"_blank\">Click here to view it!</a>");

print("<p>Now delete this file from your server.  :-)</p>");

?>

</body>

</html>

