<?

/************************************************************************************************
TiddlyWiki 1.0 copyright by Jeremy Ruston, 20 September 2004
jeremy@osmosoft.com
PhpTiddlyWiki is an extension by Patrick Curry, 2004-2007
wiki(at)patrickcurry(dot)com

This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike License.
To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/2.0/ or send
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
************************************************************************************************/

// This file is the only file you should have to edit to use PhpTiddlyWiki on your website.
// If you want to change how the site works then check out the other files.  :-)

// database definitions
$tiddly_db_host					= "hostname";						// hostname of the MySQL database
$tiddly_db_login				= "username";						// username/login to that database
$tiddly_db_pass					= "password";						// password to the database for that user
$tiddly_db_name					= "database";						// name of the specific database (collection of tables)
$tiddly_db_table_name			= "tiddly_wiki_entry";				// name of the table containing entries (hack for multiple wikis per DB)
$tiddly_db_backup_table_name	= "tiddly_wiki_entry_version";		// name of the table containing entries (hack for multiple wikis per DB)

// site definitions (only used in RSS/XML feed for now)
$tiddly_site_title	= "PhpTiddlyWiki";
$tiddly_site_url	= "http://www.yourhostname.com/tiddly/";
$tiddly_site_desc	= "A PHP-Powered Wiki, with the client-side magic of TiddlyWiki";
$tiddly_site_lang	= "en-us";
$tiddly_site_email	= "wiki(at)yourhostname(dot)com";

// site preferences
$tiddly_pref_delete	= 1; // 0 = no deleting allowed AT ALL, 1 = anyone can delete anything at any time
$tiddly_pref_vers	= 1; // 0 = no versions stored, 1 = all versions stored.  The version number is always updated

// global vars
//$locked_titles = array("SiteTitle", "SiteSubtitle", "MainMenu", "StartHere", "DownloadCode", "CreateNewTiddler");

$tiddly_name_of_script = $_SERVER['PHP_SELF']; // you can change this to a specific directory, like "/tiddly/" if you like.

?>